#! /bin/sh
#Semplice script per il backup di file remoti
#
#              MegaLab.it
#        
#Per info, vedi www.megalab.it/4485

#Queste due variabili vengono usate per creare archivi compressi separati a seconda del giorno della settimana
day_name="`date "+%a"`"
day_num="`date "+%u"`"

echo "** Inizio operazioni di rsyncaggio: giorno $day_num ($day_name) **"

#Nome utente per l'accesso al server remoto
remote_username="root"
echo "Username remoto: $remote_username"

#Indirizzo del server remoto
remote_hostname="mioserver.com"
echo "Server remoto: $remote_hostname"

#Cartella remota da fotocopiare in locale (con barra finale!)
remote_path="/var/www/"
echo "Cartella remota: $remote_path"

#Cartella locale nella quale copiare i file remoti (con barra finale!) (su Windows, deve iniziare con /cygdrive/) 
local_path="/cygdrive/c/Backup/Sito/fotocopia_live/"
echo "Cartella locale: $local_path"

#Cartella locale nella quale memorizzare le copie compresse (con barra finale!) (su Windows, deve iniziare con /cygdrive/) 
local_archive_path="/cygdrive/c/Backup/Sito/"
echo "Cartella locale per gli archivi: $local_archive_path"

#Prefisso del nome da assegnare alle copie di backup archiviate
archive_name="MegaBackup_rsync_"
echo "Prefisso file di archivio: $archive_name"

#Percorso per raggiungere l'eseguibile da riga di comando di 7-Zip  (su Windows, deve iniziare con /cygdrive/) 
local_7z_path="/cygdrive/c/Programmmi/7-Zip/7z.exe"
echo "Eseguibile 7-Zip: $local_7z_path"

#Non modificare (deriva il percorso in stile Windows partendo da quello in Cygdrive)
local_path_windows=${local_path:10:1}":/"${local_path:12:200}"*"
echo "local_path_windows: $local_path_windows"
local_path_windows_archive=${local_archive_path:10:1}":/"${local_archive_path:12:200}
echo "local_path_windows_archive: $local_path_windows_archive"

echo "------------------------------------------"

echo "Rimuovo l'archivio $local_archive_path$archive_name$day_num.7z"
rm -f $local_path_windows_archive$archive_name$day_num.7z

echo "Lancio rsync"
rsync --recursive --compress --progress -vv --delete --exclude='*.serialized' --exclude='.svn/' --exclude='tmp/*' $remote_username@$remote_hostname:$remote_path "$local_path"

echo "Creo una copia compressa della cartella appena scaricata"
$local_7z_path a -mx=0 "$local_path_windows_archive$archive_name$day_num.7z" "$local_path_windows"


echo "** Operazione terminata **"